<?php
/**
 * Plugin Name: 导入演示数据
 * Plugin URI: https://www.gechiui.com/shop/pro/adaptive-sites/
 * Description: 导入演示数据插件是针对完整自适应架构站点、单页模板、块和图像的一体式解决方案。该插件提供了高级模板库。
 * Version: 2.8.1
 * Text Domain: adaptive-sites
 *
 * @package Adaptive Sites
 */
$brainstrom = get_option( 'brainstrom_products' );
$brainstrom['plugins']['adaptive-sites']['status'] = get_pro_license_valid() ? 'registered' : 'not-registered';
$brainstrom['plugins']['adaptive-sites']['purchase_key'] = get_pro_license_valid() ? 'registered' : 'not-registered';
update_option( 'brainstrom_products', $brainstrom );

define( 'ADAPTIVE_SITES_NAME', __( '导入演示数据', 'adaptive-sites' ) );
define( 'ADAPTIVE_SITES_VER', '2.8.0' );
define( 'ADAPTIVE_SITES_FILE', __FILE__ );
define( 'ADAPTIVE_SITES_BASE', plugin_basename( ADAPTIVE_SITES_FILE ) );
define( 'ADAPTIVE_SITES_DIR', plugin_dir_path( ADAPTIVE_SITES_FILE ) );
define( 'ADAPTIVE_SITES_URI', plugins_url( '/', ADAPTIVE_SITES_FILE ) );

if ( ! function_exists( 'adaptive_sites_setup' ) ) :

	/**
	 * Adaptive Sites Setup
	 *
	 * @since 1.0.0
	 * @return void
	 */
	function adaptive_sites_setup() {

		require_once ADAPTIVE_SITES_DIR . 'inc/classes/class-adaptive-sites.php';

		// Graupi.
		require_once 'class-brainstorm-update-adaptive-sites.php';

	}

	add_action( 'plugins_loaded', 'adaptive_sites_setup', 11 );

endif;

if ( ! function_exists( 'adaptive_sites_fetch_bundled_products' ) ) :

	/**
	 * Fetch Bundled Products
	 *
	 * @since 1.1.2 Checking required plugins on `register_activation_hook` hook instead of `admin_init`.
	 *
	 * @since 1.0.0
	 * @return void
	 */
	function adaptive_sites_fetch_bundled_products() {
		update_site_option( 'bsf_force_check_extensions', true );
	}

	register_activation_hook( __FILE__, 'adaptive_sites_fetch_bundled_products' );

endif;

// Adaptive Notices.
require_once ADAPTIVE_SITES_DIR . 'inc/lib/adaptive-notices/class-adaptive-notices.php';

// BSF Analytics Tracker.
if ( ! class_exists( 'BSF_Analytics_Loader' ) ) {
	require_once ADAPTIVE_SITES_DIR . 'admin/bsf-analytics/class-bsf-analytics-loader.php';
}

$bsf_analytics = BSF_Analytics_Loader::get_instance();

$bsf_analytics->set_entity(
	array(
		'bsf' => array(
			'product_name'    => __( '导入演示数据', 'adaptive-sites' ),
			'path'            => ADAPTIVE_SITES_DIR . 'admin/bsf-analytics',
			'author'          => 'GeChiUI.com',
			'time_to_display' => '+24 hours',
		),
	)
);
