(function($){

	AdaptiveSitesAPI = {

		/**
		 * API Request
		 */
		_api_request: function( args, callback ) {

			var params = {
				method: 'GET',
	            cache: 'default',
           	};

			if( adaptiveSitesVars.headers ) {
				params['headers'] = adaptiveSitesVars.headers;
			}

			fetch( adaptiveSitesVars.ApiURL + args.slug, params).then(response => {
				if ( response.status === 200 ) {
					return response.json().then(items => ({
						items 		: items,
						items_count	: response.headers.get( 'x-gc-total' ),
						item_pages	: response.headers.get( 'x-gc-totalpages' ),
					}))
				} else {
					$(document).trigger( 'adaptive-sites-api-request-error' );
					return response.json();
				}
			})
			.then(data => {
				if( 'object' === typeof data ) {
					data['args'] = args;
					if( data.args.id ) {
						adaptiveSitesVars.stored_data[ args.id ] = $.merge( adaptiveSitesVars.stored_data[ data.args.id ], data.items );
					}
					data['args']['favorites'] = adaptiveSitesVars.favorite_data;

					if( 'undefined' !== typeof args.trigger && '' !== args.trigger ) {
						$(document).trigger( args.trigger, [data] );
					}

					if( callback && typeof callback == "function"){
						callback( data );
				    }
			   	}
			});

		},

		/**
		 * API Request
		 */
		_api_single_request: function( args, callback ) {

			var params = {
				method: 'GET',
	            cache: 'default',
           	};

			if( adaptiveSitesVars.headers ) {
				params['headers'] = adaptiveSitesVars.headers;
			}

			fetch( adaptiveSitesVars.ApiURL + args.slug, params).then(response => {
				if ( response.status === 200 ) {
					return response.json();
				} else {
					$(document).trigger( 'adaptive-sites-api-request-error' );
					return response.json();
				}
			})
			.then(data => {
				if( 'object' === typeof data ) {
					// data['args']['favorites'] = adaptiveSitesVars.favorite_data;

					if( 'undefined' !== typeof args.trigger && '' !== args.trigger ) {
						$(document).trigger( args.trigger, [data] );
					}

					if( callback && typeof callback == "function"){
						callback( data );
				    }
			   	}
			});

		},

	};

})(jQuery);
