(function($){
    
    $scope = {};

    AdaptiveImageCommon = {

        images: {},
        image: {},
        action: '',
        offset: 0,
        loadingStatus: true,
        config: {
            key            : adaptiveImages.pixabay_api_key,
            q              : '',
            lang           : 'en',
            image_type     : 'all',
            orientation    : 'all',
            category       : '',
            min_width      : 0,
            min_height     : 0,
            colors         : '',
            editors_choice : false,
            safesearch     : true,
            order          : 'popular',
            page           : $( 'body' ).data( 'page' ),
            per_page       : 30,
            callback       : '',
            pretty         : true
        },
        canSave: false,
        infiniteLoad: false,
        uploader: {},
        file: {},
        frame: {},
        isPreview: false,
        apiStatus: true,
        id : '',
        isValidating: false,
        scopeSet: false,

        init: function() {
            this._bind();
        },

        /**
         * Binds events for the Adaptive Sites.
         *
         * @since 1.0.0
         * @access private
         * @method _bind
         */
        _bind: function() {

            // Triggers.
            $( document ).on( "ast-image__refresh", AdaptiveImageCommon._initImages );
            $( document ).on( "ast-image__set-scope", AdaptiveImageCommon._setScope );
            $( document ).on( "click", ".ast-image__list-img-overlay", AdaptiveImageCommon._preview );
            $( document ).on( "click", ".ast-image__go-back-text", AdaptiveImageCommon._goBack );
            $( document ).on( "click", ".ast-image__save", AdaptiveImageCommon._save );
            $( document ).on( "click", ".ast-image__filter-safesearch input", AdaptiveImageCommon._filter );
            $( document ).on( "change", ".ast-image__filter select", AdaptiveImageCommon._filter );
            $( document ).on( "click", ".ast-image__edit-api", AdaptiveImageCommon._editAPI );
            $( document ).on( "click", ".ast-image__browse-images", AdaptiveImageCommon._browse );
            $( document ).on( "click", ".ast-image__download-icon", AdaptiveImageCommon._saveFromScreen );
        },

        _saveFromScreen: function() {

            let saveIcon = $(this);
            let source = saveIcon.closest('.ast-image__list-img-overlay');

            saveIcon.addClass( 'installing' );

            AdaptiveImageCommon.image = {
                'largeImageURL': source.data( 'img-url' ),
                'tags' : source.find( 'span:first-child' ).html(),
                'id' : source.data( 'img-id' ),
            };

            AdaptiveImageCommon._saveAjax( function ( data ) {
                if ( undefined == data.data ) {
                    return;
                }
                adaptiveImages.saved_images = data.data['updated-saved-images'];
                gc.media.view.AdaptiveAttachmentsBrowser.object.photoUploadComplete( data.data );
                saveIcon.text( 'Done' );
                saveIcon.removeClass( 'installing' );
                AdaptiveImageCommon._empty();
            } );
        },

        _browse: function() {
            $scope.find( '.ast-image__search' ).trigger( 'keyup' );
        },

        _editAPI: function( event ) {
            event.stopPropagation();
            gc.media.view.AdaptiveAttachmentsBrowser.images = [];
            $scope.find( '.ast-image__loader-wrap' ).show();
            $scope.find( '.ast-image__skeleton' ).html( '' );
            $scope.find( '.ast-image__skeleton' ).attr( 'style', '' );
            $scope.find( '.ast-image__search' ).trigger( 'keyup' );
            $scope.find( '.ast-image__loader-wrap' ).hide();
        },

        _filter: function() {
            let safesearch = $scope.find( '.ast-image__filter-safesearch input:checked' ).length ? true : false;
            let category = $scope.find( '.ast-image__filter-category select' ).val();
            let orientation = $scope.find( '.ast-image__filter-orientation select' ).val();
            let order = $scope.find( '.ast-image__filter-order select' ).val();

            AdaptiveImageCommon.config.safesearch = safesearch;
            AdaptiveImageCommon.config.orientation = orientation;
            AdaptiveImageCommon.config.category = category;
            AdaptiveImageCommon.config.order = order;

            $scope.find( '.ast-image__search' ).trigger( 'keyup' );
            $scope.find( '.ast-image__loader-wrap' ).show();
        },

        _save: function() {

            if ( ! AdaptiveImageCommon.canSave ) {
                return;
            }

            let thisBtn = $( this )

            if ( thisBtn.data( 'import-status' ) ) {
                return;
            }

            thisBtn.text( adaptiveImages.downloading );
            thisBtn.addClass( 'installing' );

            AdaptiveImageCommon.canSave = false;

            AdaptiveImageCommon._saveAjax( function ( data ) {
                if ( undefined == data.data ) {
                    return;
                }
                adaptiveImages.saved_images = data.data['updated-saved-images'];
                gc.media.view.AdaptiveAttachmentsBrowser.object.photoUploadComplete( data.data );
                thisBtn.text( 'Done' );
                thisBtn.removeClass( 'installing' );
                AdaptiveImageCommon._empty();
            } );

        },

        _saveAjax: function( callback ) {

            // Work with JSON page here
            $.ajax({
                url: adaptiveImages.ajaxurl,
                type: 'POST',
                dataType: 'json',
                data: {
                    'action' : 'adaptive-sites-create-image',
                    'url' : AdaptiveImageCommon.image.largeImageURL,
                    'name' : AdaptiveImageCommon.image.tags,
                    'id' : AdaptiveImageCommon.image.id,
                    '_ajax_nonce' : adaptiveImages._ajax_nonce,
                },
            })
            .fail(function( jqXHR ){
                console.log( jqXHR );
            })
            .done( callback );
        },

        _empty: function() {

            AdaptiveImageCommon.image = {};
            AdaptiveImageCommon.canSave = false;
            AdaptiveImageCommon.uploader = {};
            AdaptiveImageCommon.file = {};
            AdaptiveImageCommon.isPreview = false;
        },

        _goBack: function() {

            AdaptiveImageCommon._empty();

            $( document ).trigger( 'ast-image__refresh' );

            $scope.find( '.ast-image__skeleton' ).show();
            $scope.removeClass( 'preview-mode' );
            $scope.find( '.ast-attachments-search-wrap' ).children().show();
            $scope.find( '.ast-image__go-back' ).remove();
            $scope.find( '.ast-image__save-wrap' ).remove();
            $scope.find( '.ast-image__preview-skeleton' ).hide();
            $scope.find( '.ast-image__preview-skeleton' ).html( '' );

            let wrapHeight = ( AdaptiveImageCommon.offset - 210 );
            $scope.find( '.ast-image__skeleton-inner-wrap' ).css( 'height', wrapHeight );
        },

        _preview: function(event) {

            if( event && event.target.classList.contains( 'ast-image__download-icon' ) ) {
                return;
            }

            AdaptiveImageCommon.isPreview = true;

            let height = ( AdaptiveImageCommon.offset - 190 );
            $scope.find( '.ast-image__skeleton-inner-wrap' ).css( 'height', height );

            setTimeout( function() {
                $scope.find( '.ast-image__loader-wrap' ).hide();
            }, 200 );

            AdaptiveImageCommon.image = {
                'largeImageURL': $( this ).data( 'img-url' ),
                'tags' : $( this ).find( 'span:first-child' ).html(),
                'id' : $( this ).data( 'img-id' ),
            };

            let preview = gc.template( 'ast-image-single' );
            let single_html = preview( AdaptiveImageCommon.image );

            let save_btn = gc.template( 'ast-image-save' );
            let single_btn = save_btn( AdaptiveImageCommon.image );

            let wrapHeight = $scope.find( '.ast-image__skeleton-inner-wrap' ).outerHeight();
            wrapHeight = ( wrapHeight - 60 );

            $scope.find( '.ast-image__skeleton' ).hide();
            $scope.addClass( 'preview-mode' );
            $scope.find( '.ast-attachments-search-wrap' ).children().hide();
            $scope.find( '.ast-image__search-wrap' ).before( $( '#tmpl-ast-image-go-back' ).text() );
            $scope.find( '.ast-image__search-wrap' ).after( single_btn );
            $scope.find( '.ast-image__preview-skeleton' ).html( single_html );
            $scope.find( '.ast-image__preview-skeleton' ).show();
            $scope.find( '.single-site-preview' ).css( 'max-height', wrapHeight );

            AdaptiveImageCommon.canSave = true;
        },

        _setScope: function() {

            AdaptiveImageCommon.frame = gc.media.view.AdaptiveAttachmentsBrowser.object.$el.closest( '.media-frame' );
            $scope = AdaptiveImageCommon.frame.find( '.ast-attachments-browser' );

            if ( undefined == $scope ) {
                return;
            }

            if ( AdaptiveImageCommon.scopeSet ) {
                return;
            }
            
            $( 'body' ).data( 'page', 1 );
            let skeleton = $( '#tmpl-ast-image-skeleton' ).text();
            $scope.append( skeleton );

            let pixabay_filter = gc.template( 'ast-image-filters' );
            if ( $scope.find( '.ast-image__filter-wrap' ).length > 0 ) {
                $scope.find( '.ast-image__filter-wrap' ).replaceWith( pixabay_filter() );
            } else {
                $scope.find( '.ast-attachments-search-wrap' ).append( pixabay_filter() );
            }

            AdaptiveImageCommon.offset = AdaptiveImageCommon.frame.outerHeight();
            let wrapHeight = ( AdaptiveImageCommon.offset - 210 );
            $scope.find( '.ast-image__skeleton-inner-wrap' ).css( 'height', wrapHeight );
            $scope.find( '.ast-image__search' ).trigger( 'keyup' );
            $scope.find( '.ast-image__loader-wrap' ).show();
            $scope.find( '.ast-image__skeleton-inner-wrap' ).scroll( AdaptiveImageCommon._loadMore );

            AdaptiveImageCommon.scopeSet = true;
        },

        _initImages: function() {  

            let loop = gc.template( 'ast-image-list' );
            let list_html = loop( gc.media.view.AdaptiveAttachmentsBrowser.images );
            let container = document.querySelector( '.ast-image__skeleton' );
            $scope.find( '.ast-image__loader-wrap' ).show();
            
            if ( AdaptiveImageCommon.infiniteLoad ) {
                AdaptiveImageCommon.images.push( gc.media.view.AdaptiveAttachmentsBrowser.images );
                $scope.find( '.ast-image__skeleton' ).append( list_html );
            } else {
                AdaptiveImageCommon.images = gc.media.view.AdaptiveAttachmentsBrowser.images;
                $scope.find( '.ast-image__skeleton' ).html( list_html );
            }
            AdaptiveImageCommon.loadingStatus = true;
            if ( $scope.find( '.ast-image__list-wrap' ).length ) {
                imagesLoaded( container, function() {
                    $scope.find( '.ast-image__list-wrap' ).each( function( index ) {
                        $( this ).removeClass( 'loading' );
                        $( this ).addClass( 'loaded' );
                    } );
                    $scope.find( '.ast-image__loader-wrap' ).hide();
                });
            } else {
                $scope.find( '.ast-image__loader-wrap' ).hide();
            }
        },

        _loadMore: function() {

            if( AdaptiveImageCommon.isPreview ) {
                return;
            }

            let page = $( 'body' ).data( 'page' );
            page = ( undefined == page ) ? 2 : ( page + 1 );

            if ( undefined != $scope.find( '.ast-image__list-wrap:last' ).offset() ) {

                if( ( $( window ).scrollTop() + AdaptiveImageCommon.offset ) >= ( $scope.find( '.ast-image__list-wrap:last' ).offset().top ) ) {

                    if ( AdaptiveImageCommon.loadingStatus ) {

                        $scope.find( '.ast-image__loader-wrap' ).show();

                        AdaptiveImageCommon.loadingStatus = false;
                        AdaptiveImageCommon.infiniteLoad = true;
                        AdaptiveImageCommon.config.page = page;
                         
                        $( 'body' ).data( 'page', page );

                        $scope.find( '.ast-image__search' ).trigger( 'infinite' );
                    }
                }
            }
        },
    };

    /**
     * Initialize AdaptiveImageCommon
     */
    $( function(){

        AdaptiveImageCommon.init();

    });

})(jQuery);

