(function($){

	AdaptiveSitesImportStatus = {
        timer: null,
		ajax_in_process: false,
		current_step: null,
		interval: $( '.adaptive-sites-import-screen' ).length ? 1000 : 10000,

		/**
		 * Init
		 */
		init: function()
		{
            this.start();
        },

		/**
		 * Start
		 */
        start: function() {
            AdaptiveSitesImportStatus.timer = setInterval( AdaptiveSitesImportStatus.check_status, AdaptiveSitesImportStatus.interval );
        },

		/**
		 * Check Status
		 */
        check_status: function() {
			if( false === AdaptiveSitesImportStatus.ajax_in_process ) {
				AdaptiveSitesImportStatus.ajax_in_process = true;
				AdaptiveSitesImportStatus._ajax_request();
            }
		},

		/**
		 * Ajax Request
		 */
		_ajax_request: function() {
			$.ajax({
				url: AdaptiveSitesImportStatusVars.ajaxurl,
				type: 'POST',
				data: {
					'action' : 'adaptive_sites_check_import_status',
					'_ajax_nonce' : AdaptiveSitesImportStatusVars._ajax_nonce,
				},
			})
			.done(function (result) {
				
				AdaptiveSitesImportStatus.ajax_in_process = false;

				// Admin Bar UI markup.
				if( "complete" === result.data.response.step || "fail" === result.data.response.step ) {
					AdaptiveSitesImportStatus.stop();

					var response_message = '<span class="dashicons dashicons-no-alt"></span> Site Import Failed';
					if( "complete" === result.data.response.step ) {
						response_message = '<span class="dashicons dashicons-yes"></span>' + response_message;
					}

					$('#adaptive-sites-import-status-admin-bar').html( response_message );
					
				} else {
					$('#adaptive-sites-import-status-admin-bar').html( '<span class="loading"></span>' + result.data.response.message );
				}

				// Admin page UI markup.
				var currentStep = $( '.import-step[data-step="' + result.data.response.step + '"]' );
				if( currentStep.length ) {
					if( "complete" === result.data.response.step || "fail" === result.data.response.step ) {
						$( '.import-step' ).removeClass( 'processing' ).addClass( 'success' );;
					} else if( AdaptiveSitesImportStatus.current_step !== result.data.response.step ) {
						AdaptiveSitesImportStatus.current_step = result.data.response.step;

						currentStep.prevAll().removeClass('processing').addClass('success');
						currentStep.addClass('processing');
					}
				}
			})
			.fail(function (err) {
				AdaptiveSitesImportStatus.ajax_in_process = false;

				// Stop.
				AdaptiveSitesImportStatus.stop();
			});
		},

		/**
		 * Step
		 */
        stop: function() {
            clearInterval(AdaptiveSitesImportStatus.timer);
        }

	};

	/**
	 * Initialize AdaptiveSitesImportStatus
	 */
	$(function(){
		AdaptiveSitesImportStatus.init();
	});

})(jQuery);
