<?php
/**
 * Adaptive Sites Compatibility for 3rd party plugins.
 *
 * @package Adaptive Sites
 * @since 1.0.11
 */

if ( ! class_exists( 'Adaptive_Sites_Compatibility' ) ) :

	/**
	 * Adaptive Sites Compatibility
	 *
	 * @since 1.0.11
	 */
	class Adaptive_Sites_Compatibility {

		/**
		 * Instance
		 *
		 * @access private
		 * @var object Class object.
		 * @since 1.0.11
		 */
		private static $instance;

		/**
		 * Initiator
		 *
		 * @since 1.0.11
		 * @return object initialized object of class.
		 */
		public static function instance() {
			if ( ! isset( self::$instance ) ) {
				self::$instance = new self();
			}
			return self::$instance;
		}

		/**
		 * Constructor
		 *
		 * @since 1.0.11
		 */
		public function __construct() {

			// Plugin - Adaptive.
			require_once ADAPTIVE_SITES_DIR . 'inc/classes/compatibility/adaptive/class-adaptive-sites-compatibility-adaptive.php';

			// Plugin - WooCommerce.
			require_once ADAPTIVE_SITES_DIR . 'inc/classes/compatibility/woocommerce/class-adaptive-sites-compatibility-woocommerce.php';

			// Plugin - LearnDash LMS.
			require_once ADAPTIVE_SITES_DIR . 'inc/classes/compatibility/sfwd-lms/class-adaptive-sites-compatibility-sfwd-lms.php';

			// Plugin - Elementor.
			require_once ADAPTIVE_SITES_DIR . 'inc/classes/compatibility/elementor/class-adaptive-sites-compatibility-elementor.php';

			// Plugin - LearnDash.
			require_once ADAPTIVE_SITES_DIR . 'inc/classes/compatibility/learndash/class-adaptive-sites-compatibility-learndash.php';
		}

	}

	/**
	 * Kicking this off by calling 'instance()' method
	 */
	Adaptive_Sites_Compatibility::instance();

endif;


