<?php
/**
 * White Label Form
 *
 * @package Adaptive Sites
 */

?>
<?php
// Bail from displaying settings screen if Adaptive Pro is older version.
if ( ! is_callable( 'Adaptive_Ext_White_Label_Markup::branding_key_to_constant' ) ) {
	return;
}
?>
<li>
	<div class="branding-form postbox">
		<button type="button" class="handlediv button-link" aria-expanded="true">
			<span class="screen-reader-text"><?php echo esc_html( $plugin_name ); ?></span>
			<span class="toggle-indicator" aria-hidden="true"></span>
		</button>

		<h2 class="hndle ui-sortable-handle">
			<span><?php echo esc_html( $plugin_name ); ?></span>
		</h2>

		<div class="inside">
			<div class="form-wrap">
				<div class="form-field">
					<label><?php esc_html_e( '插件名称：', 'adaptive-sites' ); ?>
						<input type="text" name="ast_white_label[adaptive-sites][name]" class="placeholder placeholder-active" <?php disabled( defined( Adaptive_Ext_White_Label_Markup::branding_key_to_constant( 'adaptive-sites', 'name' ) ), true, true ); ?> value="<?php echo esc_attr( Adaptive_Ext_White_Label_Markup::get_whitelabel_string( 'adaptive-sites', 'name' ) ); ?>">
					</label>
				</div>
				<div class="form-field">
					<label><?php esc_html_e( '插件描述:', 'adaptive-sites' ); ?>
						<textarea name="ast_white_label[adaptive-sites][description]" class="placeholder placeholder-active" <?php disabled( defined( Adaptive_Ext_White_Label_Markup::branding_key_to_constant( 'adaptive-sites', 'description' ) ), true, true ); ?> rows="2"><?php echo esc_attr( Adaptive_Ext_White_Label_Markup::get_whitelabel_string( 'adaptive-sites', 'description' ) ); ?></textarea>
					</label>
				</div>
				<div class="clear"></div>
			</div>
		</div>
	</div>
</li>
