<?php
/**
 * Premium License
 *
 * @since 1.0.0
 * @package Adaptive Pro Sites
 */

$status_class = 'default';

if ( isset( $_POST['bsf_license_manager']['license_key'] ) && empty( $_POST['bsf_license_manager']['license_key'] ) ) { // phpcs:ignore GeChiUI.Security.NonceVerification.Missing
	$status_class = 'empty';
} elseif ( isset( $_POST['bsf_license_activation']['success'] ) ) { // phpcs:ignore GeChiUI.Security.NonceVerification.Missing
	$current_status = esc_attr( $_POST['bsf_license_activation']['success'] ); // phpcs:ignore GeChiUI.Security.NonceVerification.Missing

	$status_class = 'fail';
	if ( $current_status ) {
		$status_class = 'success';
	}
}

?>

<div id="adaptive-sites-license-form" class="adaptive-sites-license-form-status-<?php echo esc_attr( $status_class ); ?>">
	<div class="inner">
		<?php
		switch ( $status_class ) {
			case 'success':
				?>
					<div class="adaptive-sites-success-message">
						<p><?php esc_html_e( '恭喜你!您已经成功激活了您的启动器模板许可密钥—等待您的是一个美丽的模板世界。', 'adaptive-sites' ); ?></p>
					</div>
					<?php
				break;

			case 'empty':
			case 'fail':
				?>
					<div class="adaptive-sites-fail-message">
						<p><?php esc_html_e( '哎呀!似乎输入的许可证密钥无效/过期。如果你觉得这是一个错误，请联系我们的支持团队。', 'adaptive-sites' ); ?></p>
					</div>
					<?php
				break;

			case 'default':
			default:
				?>
					<div class="adaptive-sites-welcome-message">
						<p><?php esc_html_e( '这是一个高级模板，可与基本捆绑包和增长捆绑包。', 'adaptive-sites' ); ?></p>
						<p><?php esc_html_e( '如果您已经拥有这些捆绑包之一，请验证导入模板的许可证密钥。', 'adaptive-sites' ); ?></p>
					</div>
					<?php
				break;
		}

			$bsf_product_id = bsf_extract_product_id( ADAPTIVE_SITES_DIR );
			$args           = array(
				'product_id'                       => $bsf_product_id,
				'button_text_activate'             => esc_html__( '激活许可证', 'adaptive-sites' ),
				'button_text_deactivate'           => esc_html__( '禁用许可证', 'adaptive-sites' ),
				'license_form_title'               => '',
				'license_deactivate_status'        => esc_html__( '您的许可证未激活!', 'adaptive-sites' ),
				'license_activate_status'          => esc_html__( '您的许可证已激活!', 'adaptive-sites' ),
				'submit_button_class'              => 'adaptive-product-license button-default',
				'form_class'                       => 'form-wrap bsf-license-register-' . esc_attr( $bsf_product_id ),
				'bsf_license_form_heading_class'   => 'adaptive-license-heading',
				'bsf_license_active_class'         => 'success-message',
				'bsf_license_not_activate_message' => 'license-error',
				'size'                             => 'regular',
				'bsf_license_allow_email'          => false,
			);
			// @codingStandardsIgnoreStart
			echo bsf_license_activation_form( $args );
			// @codingStandardsIgnoreEnd
			?>

	</div>
</div>
